#include <iostream>
#include <list>
#include <iterator>

#include "Hashtable.h"
#include "HashFunctions.h"

using namespace std;

class Student {
public:
  string name;
  int year;
  string subject;
  float avg;

  Student() {}

  Student(string name, int year, string subject, float avg) {
    /* TODO */
  }

  friend std::ostream& operator<< (std::ostream &out, const Student& student);
};

std::ostream& operator<< (std::ostream &out, const Student& student) {
  cout << student.name;
  return out;
}

int main() {
  Hashtable<string, Student> students(5, &smart_hash);

  Student s1("BoJack Horseman", 4, "Philosophy", 9.5);
  Student s2("Princess Carolyn", 3, "Business", 8.0);
  Student s3("Todd Chavez", 1, "Law", 3.0);
  Student s4("Diane Nguyen", 3, "English Literature", 10.0);
  Student s5("Mr. Peanutbutter", 4, "Drama", 7.0);
  Student s6("Sarah Lynn", 1, "Drama", 2.5);

  cout << "------------------------ HASHTABLE INITIAL --------------------------\n";
  /* TODO: Add students to hashtable */
  students.print_hashtable();

  cout << "\n------------------------ CAUTARE STUDENT ----------------------------\n";
  Student impostor("Bender Bending Rodriguez", 4, "Bending Science", 10.0);
  /* TODO: Find possible student */

  cout << "\n------------------------ HASHTABLE DUPA ELIMINARI -------------------\n";
  /* TODO: Remove students */
  students.print_hashtable();

  cout << "\n------------------------ STUDENTI CU BURSA --------------------------\n";
  /* TODO: Find and print students */

}
